import createDecorator from '@loafer/core/util/decorators/createDecorator';
import InjectableDefinition from '@loafer/context/definition/InjectableDefinition';
import { getInjectableDefinition } from '@loafer/context/util/metadata';

const PreDestroy = createDecorator('PreDestroy', {
  methodDecorator: (target: Object, propertyKey: string, descriptor: TypedPropertyDescriptor<any>): TypedPropertyDescriptor<any> => {
    let injectableDefinition = getInjectableDefinition(target, false);
    if (undefined === injectableDefinition) {
      throw new Error('Cannot apply @PreDestroy decorator on the not @Injectable or @Injectable stereotype class.');
    }
    injectableDefinition.addPreDestroy(propertyKey);
    return descriptor;
  },
});

export default PreDestroy;
