import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants';

import AppContext from '@loafer/context/AppContext';

import DefaultPouchFactory from '@loafer/pouches/factory/implement/DefaultPouchFactory';

class DefaultAppContext implements AppContext {
  private readonly pouchFactory: DefaultPouchFactory;

  public constructor() {
    this.pouchFactory = new DefaultPouchFactory();
  }

  public getPouchFactory(): DefaultPouchFactory {
    return this.pouchFactory;
  }

  public getPouch(qualifier: PropertyType, clazz: ClassType, ...args: any[]): any {
    return this.pouchFactory.getPouch(qualifier, clazz, args);
  }
  public getPouchByType(clazz: ClassType, qualifier: PropertyType, ...args: any[]): any {
    return this.pouchFactory.getPouchByType(clazz, qualifier, args);
  }

}

export default DefaultAppContext;
