import InjectConfig from '@loafer/pouches/decorator/InjectConfig';
import InjectDefinition from '@loafer/pouches/definition/InjectDefinition';
import createDecorator from '@loafer/core/util/decorators/createDecorator';
import { getInjectDefinition } from '@loafer/pouches/util/metadata';

const Inject = (injectConfig: InjectConfig = {}) => createDecorator('Inject', {
  propertyDecorator: (target: Object, propertyKey: string | symbol): void => {
    let injectDefinition: InjectDefinition = getInjectDefinition(target, true);
    injectDefinition.addInject(injectConfig, propertyKey);
  },
  parameterDecorator: (target: Object, propertyKey: string | symbol, parameterIndex: number): void => {
    let injectDefinition: InjectDefinition = getInjectDefinition(target, true);
    injectDefinition.addInject(injectConfig, propertyKey, parameterIndex);
  },

});

export default Inject;
