import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants';

interface PouchFactory {
  /**
   * @param qualifier is identity of pouch
   * @param clazz is type of pouch (if clazz is not specified, set the undefined)
   * @param args are argument of target constructor
   * @returns an instance of pouch
   */
  getPouch(qualifier: PropertyType, clazz: ClassType, ...args: any[]): any;
  /**
   * @param clazz is type of pouch
   * @param qualifier is identity of pouch (if qualifier is not specified, set the undefined)
   * @param args are argument of target constructor
   * @returns an instance of pouch
   */
  getPouchByType(clazz: ClassType, qualifier: PropertyType, ...args: any[]): any;

}

export default PouchFactory;
